# MongoDB数据库
1、开启MongoDB服务
```
 mongod --dbpath "C:\mongoodb\data"
```
2、连接数据库
```
 mongo
```
### MongoDB数据库操作
1、查看所有库名
```
show dbs;
```
2、切换数据库
```
use 库名
```
3、查看当前数据库名
```
db / db.getName()
```
4、显示当前DB的状态
```
db.stats()
```
5、查看当前DB的连接的主机地址
```
db.getMongo()
```
6、查看当前DB的版本
```
db.version()
```
### 创建数据库
```
use 数据库名;
db.createCollection('users')// 创建users集合,注意集合必须是英文单词的复数
```
查看数据库中的所有集合
```
show collections
```
添加集合
```
db.createCollection('goods')
```

### 增加数据(在命令行中写时，必须一步步的写，光标不能往前移)
1、添加一条数据
```
db.users(集合名).insertOne({username:"abc",password:"123"})
```
2、添加多条数据
```
db.users.insertMany([{},{}])
```

### 删除数据
1、删除一条数据
```
db.users.deleteOne({username:"abc"})
```
2、删除所有的数据
```
db.users.remove({})
```

### 更新数据
1、更新一条数据
```
db.users.updateOne({username:"abc"},{$set:{username:"zzz",password:123456}})
db.user.updateOne({},{$set:{}})
```

### 查询数据
```
    db.user.find()     查询所有记录
	db.user.distinct('name')    以name字段去重查询
	db.user.find({age:22})     查询age=22的记录
	db.user.find({age:{$gt: 22}})   查询age>22的记录
	db.user.find({age:{$lt: 22}})   查询age<22的记录
	db.user.find({age:{$gte: 22}})   查询age>=22的记录
	db.user.find({age:{$lte: 22}})   查询age<=22的记录
	db.user.find({age:{$gte:20, $lte:30}})  查询age>=20 && age<=30的记录
	db.user.find({name:/geek/})  查询name中包含'geek'的记录
	db.user.find({name:/^geek/})  查询name以'geek'开头的记录
	db.user.find({},{name:1,age:1})  查询所有记录，只返回name和age字段（1-显示 0-不显示）
	db.user.find({age:{$gt:20}},{name:1,age:1})  查询age>20的记录，只返回name和age字段
	db.user.find().sort({age:1})  按age进行升序排列
	db.user.find().sort({age:-1})  按age进行降序排列
	db.user.find({},{name:1,age:1,_id:0}).sort({age:1})
	db.user.find({name:'geek',age:22})  查询name='geek' && age=22的记录
	db.user.find().limit(5)  只查询前5条记录
	db.user.find().skip(10)  查询10条以后的所有数据
	db.user.find().skip(5).limit(5)  查询第6~10条记录
	db.user.find({$or:[{age:20},{age:25}]})  查询age=20或者age=25的记录
	db.user.findOne()  查询满足条件的第一条记录
	db.user.find({age:{$gte:25}}).count()  查询满足条件的记录的总条数
	db.user.find({grade:{$exists:true}})  查询含有grade字段的记录
	db.user.find({sex:{$exists:true}}).count()  查询存在sex字段的记录的总条数
```